# coding: utf-8

"""
    SendinBlue API

    SendinBlue provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/sendinblue  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  | 

    OpenAPI spec version: 3.0.0
    Contact: contact@sendinblue.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RemoveCredits(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sms': 'int',
        'email': 'int'
    }

    attribute_map = {
        'sms': 'sms',
        'email': 'email'
    }

    def __init__(self, sms=None, email=None):
        """
        RemoveCredits - a model defined in Swagger
        """

        self._sms = None
        self._email = None

        if sms is not None:
          self.sms = sms
        if email is not None:
          self.email = email

    @property
    def sms(self):
        """
        Gets the sms of this RemoveCredits.
        SMS credits to be removed from the child account

        :return: The sms of this RemoveCredits.
        :rtype: int
        """
        return self._sms

    @sms.setter
    def sms(self, sms):
        """
        Sets the sms of this RemoveCredits.
        SMS credits to be removed from the child account

        :param sms: The sms of this RemoveCredits.
        :type: int
        """

        self._sms = sms

    @property
    def email(self):
        """
        Gets the email of this RemoveCredits.
        Email credits to be removed from the child account

        :return: The email of this RemoveCredits.
        :rtype: int
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this RemoveCredits.
        Email credits to be removed from the child account

        :param email: The email of this RemoveCredits.
        :type: int
        """

        self._email = email

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RemoveCredits):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
